//==============================================================================
// GLOBALS - The main global definitions for the CPhenix program - still needs
//		to be cleaned up.
// This program assumes that the main files were compiled as C files
//==============================================================================
#ifndef _GLOBALS_H_
#define _GLOBALS_H_
#ifdef __cplusplus
extern "C" {
#endif


// include support headers.  Need to figure out more later..
	
#include "3694s.h"
#include "regdefs.h"
//#include "..\\Downloaded C library code\\C\\bap.h"
// Stuff from bap.h... - download

typedef unsigned char byte;			//			// define some simple data types.
typedef unsigned short word;		
typedef unsigned long ulong;		// 

#define u8	byte
#define u16	word
#define u32	ulong
#define _FALSE_		0
#define _TRUE_		1

#include "chr3_cfg.h"
#include "string.h"




#include "printf.h"

#include "iopins.h"		// has our IO definitions defined.

//=============================================================================
//[CONSTANTS]
//=============================================================================
#define BUTTON_DOWN 0
#define BUTTON_UP 	1

#define	c1DEC		10
#define	c2DEC		100
#define	c4DEC		10000
#define	c6DEC		1000000

#define	cRR			0
#define	cRM			1
#define	cRF			2
#define	cLR			3
#define	cLM			4
#define	cLF			5

#define _BAP28_ 1
#define	WTIMERTICSPERMSMUL  	64	// BAP28 is 16mhz need a multiplyer and divider to make the conversion with /8192
#define WTIMERTICSPERMSDIV  	125 // 
#define USEINT_TIMERAV


// Define Interrupts we will process
typedef enum {_MASTER_INT_, TIMERAINT} INTS;
extern void enable(INTS ints=_MASTER_INT_);
extern void disable(INTS ints=_MASTER_INT_);


extern unsigned long GetCurrentTime(void);


extern long iabs(long s);
extern long imin (long a, long b);
extern long imax (long a, long b);
extern void GaitSelect(void);
extern short SmoothControl (short CtrlMoveInp, short CtrlMoveOut, byte CtrlDivider);


//-----------------------------------------------------------------------------
// Define Global variables
//-----------------------------------------------------------------------------
extern bool			g_fHexOn;				//Switch to turn on Phoenix
extern bool			g_fPrev_HexOn;			//Previous loop state 

//Body position
extern short		BodyPosX; 		//Global Input for the position of the body
extern short		BodyPosY; 
extern short		BodyPosZ; 

//Body Inverse Kinematics
extern short		BodyRotX1; 		//Global Input pitch of the body
extern short		BodyRotY1;		//Global Input rotation of the body
extern short		BodyRotZ1; 		//Global Input roll of the body


//[gait]
extern byte			GaitType;			//Gait type
extern short		NomGaitSpeed;		//Nominal speed of the gait

extern short		LegLiftHeight;		//Current Travel height
extern long			TravelLengthX;		//Current Travel length X
extern long			TravelLengthZ; 		//Current Travel length Z
extern long			TravelRotationY; 	//Current Travel Rotation Y

//[Single Leg Control]
extern byte			SelectedLeg;
extern short		SLLegX;
extern short		SLLegY;
extern short		SLLegZ;
extern bool			fSLHold;		 	//Single leg control mode

//--------------------------------------------------------------------
//[GP PLAYER]
extern bool	GPStart;						//Start the GP Player
extern byte	GPSeq;							//Number of the sequence
extern bool	GPEnable;						//Enables the GP player when the SSC version ends with "GP<cr>"

//[Balance]
extern bool BalanceMode;

//[TIMING]
extern unsigned long 	lTimerCnt;   //used in WTimer overflow. Will keep a 16 bit overflow so we have a 32 bit timer 
extern byte			InputTimeDelay;	//Delay that depends on the input to get the "sneaking" effect
extern word			SpeedControl;	//Adjustible Delay
extern word			SSCTime;		//Time for servo updates

// maybe should do this different
extern void	ServoDriverStart(void);
extern void	ServoDriverCommit(void);

// The defined controller must provide the following
extern void InitController(void);
extern void	ControlInput(void);
extern void	AllowControllerInterrupts(bool fAllow);


// debug handler...
extern bool g_fDBGHandleError;


#ifdef __cplusplus
}
#endif
#endif
